<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once 'inventory.conf.php';
include_once MODEL_INVENTORY;
include_once LIB_INVENTORY;
include_once $path.'/Model_adm.php';
$ESIA_WIDGET_NOTREE=true;
//on récupère le nom du serveur
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'WEBP_INVENTORY';
include_once $path.'/inc/common_node_control.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,$webp_name);
$plugin_url = $arr[0]['apache_path'];
include_once $path.'/'.$plugin_url.'/model_ts_inventory.php';

$display_path = str_replace('//','/',$path.$plugin_url."templates/adv_tab_inventory.html");
//Gestion des langues du système / utilisateur pour les données traduite.
$lang_abre =LANG;
if($user->getLang()!="")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}

if(file_exists($path.'/'.$plugin_url.'/lang/' .$lang_abre.'.php'))
{
	include $path.'/'.$plugin_url.'/lang/' .$lang_abre.'.php';
}

$params = array('filters'=>$_REQUEST['filters'],
	'order'=> $_REQUEST['cols'],
	'size'=>50,
	'paging'=>0);
if (isset($_GET['page']) && ! empty($_GET['page']))
{
	$params['paging'] = $_GET['page'];
}
if (isset($_GET['size']) && ! empty($_GET['size']))
{
	if ($_GET['size'] == 'all')
	{
		$_GET['size'] = 100;
	}
	$params['size'] = $_GET['size'];
}
$lang_abre =LANG;

if(isset($_GET['action']) && !empty($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action = '';
}
$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}

$smarty->assign('nodeid',$node->getId());
$smarty->assign('plugin_url',$plugin_url);
$smarty->assign('action', $action);
if($action == "hardware" || $action == '')
{
	
	// TOP 5 Erreur 
	$rulesTopErr = Model_inventory::getRulesInErrorByInventoryType($dbconnection, 'HARDWARE', 5);
	$smarty->assign('rulesTopErr', $rulesTopErr);
	$smarty->assign('rulesMatchState', $rulesMatchState);
	
	// Manufacturer
	$countManHardware = Model_inventory::getCountManufacturerByInventoryType($dbconnection,'HARDWARE',5,$node->getId());
	$smarty->assign('hardwareManufacturerDonut',$countManHardware);
}
else
{
	$rulesTopErr = Model_inventory::getRulesInErrorByInventoryType($dbconnection, 'SOFTWARE', 5);
	$smarty->assign('rulesTopErr', $rulesTopErr);
	$smarty->assign('rulesMatchState', $rulesMatchState);
	
	// Manufacturer 
	$countManSoftware = Model_inventory::getCountManufacturerByInventoryType($dbconnection,'SOFTWARE',5,$_GET['nodeid']);
	$smarty->assign('softwareManData',$countManSoftware);
	
}
$smarty->display($display_path);
?>
