<?php
namespace cron\inventory;
$_SERVER['DOCUMENT_ROOT'] =HTTP_PATH;
include_once HTTP_PATH.'/esia.conf.php';
include_once MVCMODEL;
require_once '/usr/local/esia/public_html/plugin/inventory/Model_inventory.php';
use Model_inventory;
function getManufacturerId($dbconnection,$manufacturer,&$array)
{
    if(empty($manufacturer))
    {
        $manufacturer="unknown";
    }
    $result = FALSE;
    foreach($array as $key => $man)
    {
        if(stripos($man, $manufacturer) !== FALSE)
        {
            $result =$key;
            break;
        }
    }
    if($result === FALSE)
    {
        // il faut ajouter le fabricant
        $id = Model_inventory::addManufacturer($dbconnection,$manufacturer);
        $array[$id]=$manufacturer;
        $result = $id;
    }
    return $result;
}
function getComponentType($dbconnection,$name,$type,&$array)
{
    if(empty($name))
    {
        $name="SOFTWARE";
    }
    $result = FALSE;
    $tmp = strtoupper($name);
    foreach($array as $key => $man)
    {
        if($man == $tmp)
        {
            $result =$key;
            break;
        }
    }
    if($result === FALSE)
    {
        // il faut ajouter le type
        $id = Model_inventory::addType($dbconnection,$tmp,$type);
        $array[$id]=$tmp;
        $result = $id;
    }
    return $result;
}
function getComponentId($array,$model,$manufacturer,$type)
{

    $result = FALSE;
    foreach($array as $key => $man)
    {
    	if($man['type'] == $type)
    	{
	    	if($man['manufacturer'] == $manufacturer)
	    	{
	    		if($man['model']==$model)
	    		{
	    			$result =$key;
	    			break;
	    		}
	    	}
    	}
    }
    return $result;
}
function getSoftwareComponentId($dbconnection,$name,$type,$manufacturer,&$element)
{
    $result = FALSE;
    foreach($element['component'] as $key => $man)
    {
    	if($man['name'] == $name)
    	{
	    	if($man['manufacturer_name'] == $manufacturer)
	    	{
	    		$result =$key;
	    		break;
	    	}
    	}
    }
    if($result === FALSE)
    {
        $type_id = getComponentType($dbconnection,$type,'SOFTWARE',$element['type']);
        $manufacturer_id = getManufacturerId($dbconnection,$manufacturer,$element['manufacturer']);
        // il faut ajouter le type
	    $id = Model_inventory::addComponent($dbconnection,$name,"","",$type_id,$manufacturer_id);
	    $tmp=array('name'=>$name,
                   'model'=>'',
                   'manufacturer_id'=>$manufacturer_id,
                   'manufacturer_name'=>$manufacturer,
                   'type_id'=> $type_id,
                   'type_name'=>$type,
                   'type'=>'SOFTWARE');
        $element['component'][$id]=$tmp;
        $result = $id;
    }
    return $result;
}
function getNetInComponentId($dbconnection,$name,$type,$manufacturer,&$element)
{
	$result = FALSE;
	foreach($element['component'] as $key => $man)
	{
		if($man['name'] == $name)
		{
			if($man['manufacturer_name'] == $manufacturer)
			{
				$result =$key;
				break;
			}
		}
	}
	if($result === FALSE)
	{
		$type_id = getComponentType($dbconnection,'NETIN','HARDWARE',$element['type']);
		$manufacturer_id = getManufacturerId($dbconnection,$manufacturer,$element['manufacturer']);
		// il faut ajouter le type
		$id = Model_inventory::addComponent($dbconnection,$name,"","",$type_id,$manufacturer_id);
		$tmp=array('name'=>$name,
			'model'=>'',
			'manufacturer_id'=>$manufacturer_id,
			'manufacturer_name'=>$manufacturer,
			'type_id'=> $type_id,
			'type_name'=>$type,
			'type'=>'HARDWARE');
		$element['component'][$id]=$tmp;
		$result = $id;
	}
	return $result;
}
function getHardwareComponentId($dbconnection,$name,$type,$manufacturer,&$element)
{
	$result = FALSE;
	foreach($element['component'] as $key => $man)
	{
		if($man['name'] == $name)
		{
			if($man['manufacturer_name'] == $manufacturer)
			{
				$result =$key;
				break;
			}
		}
	}
	if($result === FALSE)
	{
		$type_id = getComponentType($dbconnection,$type,'HARDWARE',$element['type']);
		$manufacturer_id = getManufacturerId($dbconnection,$manufacturer,$element['manufacturer']);
		// il faut ajouter le type
		$id = Model_inventory::addComponent($dbconnection,$name,"","",$type_id,$manufacturer_id);
		$tmp=array('name'=>$name,
			'model'=>'',
			'manufacturer_id'=>$manufacturer_id,
			'manufacturer_name'=>$manufacturer,
			'type_id'=> $type_id,
			'type_name'=>$type,
			'type'=>'HARDWARE');
		$element['component'][$id]=$tmp;
		$result = $id;
	}
	return $result;
}
function searchInEditorDatabase($search,$editorDatabase)
{
    $return = NULL;
    foreach($editorDatabase as $item)
    {
        if(stripos($search,$item['name'])!==FALSE)
        {
            $return = $item;
            break;
        }
    }
    return $return;
}
function trace($debug,$output)
{
	//if($debug==1 || $debug===true)
	if(isset($debug))
	{
		if(is_array($output))
		{
			print_r($output);
		}
		else
		{
			echo "DEBUG: $output\n";
		}
	}
}
function getParam($options, $shortName, $slongName, $default = null)
{
	$param = $default;
	if (isset($options[$shortName]))
	{
		$param = $options[$shortName];
	}
	elseif (isset($options[$slongName]))
	{
		$param = $options[$slongName];
	}
	// security for string
	if (is_string($param))
	{
		$param = strtolower(trim(str_replace(' ', '', $param)));
	}
	return $param;
}

function insertOrUpdateComponent($line, &$components)
{
	$componentType='';
	if(array_key_exists('version', $line))
	{
		$componentType= 'soft';
	}
	$ret = 0;
	//si 0 = insert
	//si > 0 = id à updater
	$match = 0;
    if(empty($components))
    {
        return 0;
    }
    $line['type'] = strtoupper($line['type']);
	foreach($components as $key => $compo)
	{
        if(isset($compo['found']) )
        {
            continue;
        }
		if($line['type'] =='NETINT' )
		{
            $compo['component'] = trim($compo['component']);
            $line['name'] = trim($line['name']);
            $compo['description'] = trim($compo['description']);
            if(!isset($line['fullname']))
            {
                $line['fullname'] = '';
            }
            else
            {
                $line['fullname'] = trim($line['fullname']);
            }

            if( $compo['component'] == $line['name'] || $compo['description'] == $line['fullname'])
            {
                $ret = -1;
    			$mac=$line['option']['macAdress'];
    			if(!empty($mac))
    			{
    				if($compo['macadress'] == $mac && $compo['ip'] == $line['option']['IP'])
    				{
    					$ret = -1;
    				}
    				else
    				{
    					$ret = $compo['built_id'];
    				}
                }
            }
		} //le composant est identique en terme de nom
		elseif($compo['component'] == $line['name'] && $line['type']==$compo['type'])
		{
				if($componentType =='soft')
				{
                    $ret = $compo['built_id'];
					if(!empty($line['version']))
					{
						if($compo['version'] == $line['version'])
						{
                            $ret = -1;
						}
					}
				}//type identique on passe en chassis
				elseif($compo['type']=='CHASSIS')
				{
					$ret = $compo['built_id'];
				}
                else
                {
                    $ret = $compo['built_id'];
                }
				if(!empty($line['serial']))
				{
					if($line['serial'] == $compo['serial'])
					{
						$ret =-1;
					}
				}
		}
		elseif($compo['type']=='CHASSIS' && $line['type'] =='CHASSIS' )
		{
			$ret = $compo['built_id'];
		}

		if($ret != 0  )
		{
			$components[$key]['found'] =1;
			break;
		}
	}
	return $ret;
}
?>
