#!/usr/bin/php
<?php
define('HTTP_PATH', '/usr/local/esia/public_html/');
define('CRON_PATH', HTTP_PATH.'/plugin/inventory/cron/');

define('DIRECT_INVENTORY_SCAN',"check_pwsh.php");
define('NRPE_INVENTORY_SCAN',"check_nrpe");

//Définition des paramètres d'exécution
$LONG_OPTS  = array("id:","node:","groupnode:", "help",'debug');
$SHORT_OPTS ="i:n:g:hD";

require_once CRON_PATH.'cron_inventory.lib.php';
require_once CRON_PATH.'cron_inventory_import_common.php';

$task_id 	= cron\inventory\getParam($options,"i","id",NULL);

/*
$options = getopt($SHORT_OPTS, $LONG_OPTS);
$debug 	    = getParam($options,"D","Debug",NULL);
$listnode 	= getParam($options,"n","node",NULL);
$group 	= getParam($options,"g","groupnode",NULL);
*/

include_once HTTP_PATH.'/Model_adm.php';

include_once HTTP_PATH.'/libs/logo_oid.hash.php';
cron\inventory\trace($debug,'DATABASE CONNECTION');
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
cron\inventory\trace($debug,'DATABASE CONNECTION SUCCESS');
//groupe de noeud 	static function getNodeList($dbconnection,$user_id=NULL,$group=NULL,$t_return = Model_esia::NODE_ASSOC )
// Noeud => instanceNode
// All
cron\inventory\trace($debug,'IMPORTANTION MODEL INVENTORY');
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $arr[0]['apache_path'];
include_once  HTTP_PATH.$plugin_url.'/Model_inventory.php';
$editorDatabase = file_get_contents(HTTP_PATH.$plugin_url.EDITOR_DB);
$editorDatabase = json_decode($editorDatabase,true);
// on test s'il y a une groupe

cron\inventory\trace($debug,'LOAD VALUE');
$manufacturerKnown = Model_inventory::getImportManufacturer($dbconnection);
cron\inventory\trace($debug,$manufacturerKnown);
$componentType =Model_inventory::getImportType($dbconnection);
cron\inventory\trace($debug,$componentType);
$modelKnown =Model_inventory::getImportComponent($dbconnection);

cron\inventory\trace($debug,'GET NODE LIST');

cron\inventory\trace($debug,'NODE SELECTED '.count($nodes));
$inventory_array = array();

$default_auth_parameters = NULL;
if( $task_id != NULL )
{
	$file_path = '/inventory/pwsh_'.$task_id;
	if( isExistFile($file_path) )
	{
		$default_auth_parameters = getSettingsFromEncryptedFile($dbconnection,$file_path);
		$default_auth_parameters = json_decode($default_auth_parameters,TRUE);
	}
}
if( $task_id != NULL && $default_auth_parameters == NULL )
{
	echo "Unable to decrypt conf file for task id $task_id\n";
	exit(2);
}

cron\inventory\trace($debug,'START FOREACH NODES');
foreach($nodes as $node)
{
    try
    {
        $linkednodetab = false;

        $node_type = @get_class($node);
        if( strpos($node_type,'Remote')!== FALSE)
        {
            $node_type = 'Remote';
        }
        $node_id = $node->getId();
    	$linkednodetab = false;

		if( $default_auth_parameters != NULL && $node_type != 'Remote' )
		{
			cron\inventory\trace($debug,'DEFAULT_PARAMETERS SET');
			$host_add = $node->getIPAddress();
			$login = $default_auth_parameters['user'];
			$pass = $default_auth_parameters['password'];
			$conn_parameters = "-H $host_add -U $login -P '$pass'";
			$conn_parameters .= ' -J -T inventory-';
		}
		else
		{
			cron\inventory\trace($debug,'SEARCH NODE PARAMS');
	        //On recherche les params le plus souvent utiliser
	        $services = Model_esia::getServices($dbconnection,$node_id);
	        $srv_type = array();
	        $srv_auth = array();
	        foreach($services as $srv)
	        {
	            //Si on a un plugin powershell différent de unknown
				if( $srv['state'] != 3  &&  strpos($srv['check_plugin_name'],'PWSH') !== FALSE )
	            {
	                $parameters = '';
	                if( $node_type == 'Remote' && strpos($srv['path'],'check_nrpe') !== FALSE )
	                {
	                    if( preg_match('/-a\s+\S+\s+\S+/',$srv['parameter'],$matches))
	                    {
	                        $syntax = 'NRPE';
	                        $parameters = $matches[0];
	                    }
	                }
	                else
	                {
	                    $syntax = '';
	                    if( $node_type == 'Remote' && strpos($srv['check_plugin_name'],'GESA') !== FALSE )
	                    {
	                        $syntax = 'ECATP';
	                    }
	                    elseif($node_type != 'Remote' && strpos($srv['check_plugin_name'],'GESA') === FALSE)
	                    {
	                        $syntax = 'DIRECT';
	                    }

	                    if( !empty($syntax) && preg_match_all('/\-([HUPA])\s+(\S+)/',$srv['parameter'],$matches))
	                    {
	                        $params = $matches[0];
	                        sort($params);
	                        $parameters = implode(' ',$params);
	                    }
	                }

	                if( !empty($parameters))
	                {
	                    if(!isset($srv_type[$syntax]))
	                    {
	                        $srv_type[$syntax] = 1 ;
	                        $srv_auth[$syntax] = array();
	                    }
	                    else
	                    {
	                        $srv_type[$syntax]++;
	                    }
	                    if(!isset($srv_auth[$syntax][$parameters]))
	                    {
	                        $srv_auth[$syntax][$parameters] = 1;
	                    }
	                    else
	                    {
	                        $srv_auth[$syntax][$parameters]++;
	                    }
	                }
	            }
	        }
	        if( empty($srv_type))
	        {
				cron\inventory\trace($debug,'NODE PARAMS NOT FOUND');
	            continue;
	        }
			cron\inventory\trace($debug,'NODE PARAMS AVAILAIBLE');
	        arsort($srv_type);
	        $conn_type = array_keys($srv_type)[0];
	        $parameters_list = $srv_auth[$conn_type];

	        arsort($parameters_list);
	        $conn_parameters = array_keys($parameters_list)[0];

	        $path = DEFAULT_INVENTORY_PLUGIN_PATH;
	        if( $conn_type == 'NRPE' )
	        {
	            $path .= NRPE_INVENTORY_SCAN;
	            $conn_parameters = trim($conn_parameters);
	            $conn_parameters = '-S $GESASN -t 50 -c check_pwsh_inventory '.$conn_parameters.' ';
	        }
	        else
	        {
	            $path .= DIRECT_INVENTORY_SCAN;
	            $conn_parameters .= ' -J -T inventory-';
	        }
			$conn_parameters = Model_esia::getServiceExecutableParameters($dbconnection,$conn_parameters,$node);
		}
    }
    catch (Exception $e)
    {
        echo $node->getName()." DATABASE ERROR: ".$ex->getMessage."\n";
        exit(2);
    }

	$built_component = Model_inventory::getDeviceComponentsList($dbconnection, $node->getId(),'','','PWSH');
	$built_component = array_shift($built_component);
//	print_r($built_component);

    $parameter=$conn_parameters.'os';
    cron\inventory\trace($debug, 'EXEC '.$path." ".$parameter);
    $data = execImportPlugin($node,$path,$parameter);

	$linkednodetab=false;
    foreach($data as $line)
    {
		$linkednodetab = true;
		if( empty($line['fullname']))
		{
				$line['fullname'] = $line['name'] . ' (' . $line['version'].')';
		}

		$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
		if($builtid == 0)
		{
			cron\inventory\trace($debug,"COMPONENT ADD  ".$line['name']." ".$line['type']);
			$softId = cron\inventory\getSoftwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
			$insert= Model_inventory::addSoftwareComponentOnNode($dbconnection,$node->getId(),$line['name'],$line['fullname'],$softId,$line['version'],NULL,'PWSH');
		}
		elseif($builtid > 0)
		{
			cron\inventory\trace($debug,"COMPONENT UPDATE ".$line['name']." ".$line['type']);
			$insert = Model_inventory::updateSoftwareComponentOnNode($dbconnection,$builtid,$line['fullname'],$line['version'],NULL);
		}
		else
		{
			cron\inventory\trace($debug,"COMPONENT KEEP-SAME  ".$line['name']." ".$line['type']);
		}
    }
    $parameter=$conn_parameters.'hardware';
    cron\inventory\trace($debug, 'EXEC '.$path." ".$parameter);
    $data = execImportPlugin($node,$path,$parameter);

    foreach($data as $line)
    {
		$linkednodetab = true;

		if(!isset($line['version']))
		{
			$line['version'] = null;
		}

		if( empty($line['fullname']))
		{
				$line['fullname'] = $line['name'];
				if(!empty($line['version']))
				{
					 $line['fullname'] .= ' (' . $line['version'].')';
				}
		}

		$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
		if($builtid == 0)
		{
			cron\inventory\trace($debug,"COMPONENT ADD  ".$line['name']." ".$line['type']);
			$softId = cron\inventory\getSoftwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
			$insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['name'],
	                                                                $line['fullname'],$line['serial'],$softId ,$line['version'],NULL,'PWSH');
		}
		elseif($builtid > 0)
		{
			cron\inventory\trace($debug,"COMPONENT UPDATE ".$line['name']." ".$line['type']);
			$insert = Model_inventory::updateHardwareComponentOnNode($dbconnection,$builtid,$line['fullname'],$line['version'],NULL);
		}
		else
		{
			cron\inventory\trace($debug,"COMPONENT KEEP-SAME  ".$line['name']." ".$line['type']);
		}
    }
    $parameter=$conn_parameters.'software';
    cron\inventory\trace($debug, 'EXEC '.$path." ".$parameter);
    $data = execImportPlugin($node,$path,$parameter);

	foreach($data as $line)
    {
		$linkednodetab = true;

		$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
		if($builtid == 0)
		{
			cron\inventory\trace($debug,"COMPONENT ADD  ".$line['name']." ".$line['type']);
			$softId = cron\inventory\getSoftwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
			$insert= Model_inventory::addSoftwareComponentOnNode($dbconnection,$node->getId(),$line['name'],$line['fullname'],$softId,$line['version'],NULL,'PWSH');
		}
		elseif($builtid > 0)
		{
			cron\inventory\trace($debug,"COMPONENT UPDATE ".$line['name']." ".$line['type']);
			$insert = Model_inventory::updateSoftwareComponentOnNode($dbconnection,$builtid,$line['fullname'],$line['version'],NULL);
		}
		else
		{
			cron\inventory\trace($debug,"COMPONENT KEEP-SAME  ".$line['name']." ".$line['type']);
		}
    }

    if($linkednodetab && empty($built_component))
    {
        Model_esia::addNodeTabs($dbconnection, $node->getId(), 'TAB_INVENTORY');
    }

	foreach($built_component as $compo)
	{
		if(!array_key_exists('found', $compo))
		{
			cron\inventory\trace($debug, 'DELETE'.$node->getName().' '.$compo['component']);
			Model_inventory::deleteComponentOnNode($dbconnection,  $compo['built_id'], $node->getId());
		}
	}
}
cron\inventory\trace($debug,'END FOREACH NODES');
echo "OK: end import\n ";
exit(0);


function execImportPlugin($node,$path,$parameter)
{
	$arr=array();
	$ret=1;
	$exec=$path;
	$output ="";
	if(strpos($path,'check_nrpe')=== FALSE && @get_class($node)=='RemoteDevice' || @get_class($node)=='RemoteServer'  || @get_class($node)=='RemoteSwitch' )
	{
		$output = $node->getGESA()->execByECATP($path,$parameter,120);
		$output= $output['data'][0];
		$ret=0;
	}
    else
    {
    	if(strpos($path,DEFAULT_INVENTORY_PLUGIN_PATH)===FALSE)
    	{
    		$exec=DEFAULT_INVENTORY_PLUGIN_PATH.$path;
    	}
    	exec("$exec $parameter",$arr,$ret);
    	$output="";
    	foreach($arr as $line)
    	{
    		$output.=$line;
    	}
    	$output = trim($output);
    }
    if($ret == 0 && !empty($output))
    {
        $json = json_decode($output,true);
        //On test si le JSON est valide
        if(json_last_error() === JSON_ERROR_NONE)
        {
            return $json;
        }
        else
        {
        	exit(0);
            throw new Exception("BAD JSON FORMAT error $output");
        }
    }
    else
    {
        throw new Exception("Exec error $path $parameter");
    }
}
