#!/usr/bin/php
<?php
define('HTTP_PATH', '/usr/local/esia/public_html/');
define('CRON_PATH', HTTP_PATH.'/plugin/inventory/cron/');
define('NAME',"check_application.php");
define('DEFAULT_INVENTORY_SCAN',"get_snmp_inventory_default.pl");
define('DEFAULT_INVENTORY_SCAN_PARAMETER','--json -H $IP $SNMP_PARAMETERS');
define('DEFAULT_INVENTORY_OS_SCAN',"get_snmp_os_inventory.pl");
define('DEFAULT_INVENTORY_OS_SCAN_PARAMETER','--json -H $IP $SNMP_PARAMETERS -T $OSNAME');
define('DEFAULT_INVENTORY_PLUGIN_PARAMETER','--json -H $IP $SNMP_PARAMETERS -T inventory');

$LONG_OPTS  = array("node:","groupnode:", "help",'debug');
$SHORT_OPTS ="n:g:hD";
//Après l'insertion voici les variables disponnible:
//	$dbconnection: PDO objet PDO de connexion
//  $options: array    Tableau avec les données de $LONG_OPTS et $SHORT_OPTS
//  $editorDatabase array Tableau des éditeur
//  $debug: boolean si le mode début est activé
//	$nodes liste des noeuds passé par le paramètre suivants: -n/--node ou -g/--groupnode sinon c'est vide.
//  $element['manufacturer'] array contenant les fabricants
//  $element['type']         array contenant les type des élement (OS, CHASSIS, etc)
//  $element['component']    array contenant les composants récupéré
//LIBRAIRIE DISPO: Model_esia, Model_adm, Model_inventory
require_once CRON_PATH.'cron_inventory.lib.php';
require_once CRON_PATH.'cron_inventory_import_common.php';

define('NRPE_COMMANDS_FILE',DEFAULT_INVENTORY_PLUGIN_PATH.'nrpe.conf');

$inventory_array = array();
$isbuilt_insert=0;

$nodes_snmp_error = Model_inventory::getAllNodesWithSNMPServicesUnknown($dbconnection,TRUE); //TRUE => Only remote nodes

foreach($nodes as $node)
{
	$linkednodetab = false;
	$built_component = Model_inventory::getDeviceComponentsList($dbconnection, $node->getId(),'','','SNMP');
	$built_component = array_shift($built_component);
	cron\inventory\trace($debug,$built_component);
	try
	{
	    if(!empty($node->getSNMPVersion()))
	    {
	    	//Identification du fabricant
	    	cron\inventory\trace($debug,$node->getName()." STARTED SCAN");
			if(@get_class($node)=='RemoteDevice')
			{
				$is_gesa = true;
				if( isset($nodes_snmp_error[$node->getId()]) )
				{
					echo $node->getName()." SNMP ERROR: ". "incorrect SNMP settings";
					continue;
				}
			}

	    	$sysdescr = $node->getSysDescr();
	    	$objectid = $node->getSysObjectId();
	    	$is_gesa = false;

	    	$name = IANA::getSettingsName($objectid, $sysdescr);
	    	$pattern  = IANA::getPatternAdvised($is_gesa,$name);
	    	$patternfound = Model_adm::getPatternService($dbconnection,$pattern);
	    	$logo = IANA::getManufacturerLogo($objectid, $sysdescr);
            //
            //RECHERCHE SUR les OS
            //
	    	if($name =='linux' || $name =='windows')
	    	{
                //Récupération des OS et Application
	    		$parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_OS_SCAN_PARAMETER,$node);
	    		$parameter = str_replace('$OSNAME',"'".$logo['name']."'",$parameter);
	    		cron\inventory\trace($debug, 'EXEC '.DEFAULT_INVENTORY_OS_SCAN." ".$parameter);
	    		$json = execImportPlugin($node,DEFAULT_INVENTORY_OS_SCAN,$parameter);
                foreach($json as $line)
                {
                    try
                    {
                        //recherche dans la base de donnée logiciel
                    	if(empty($line['manufacturer']))
                        {
	                        $editor = cron\inventory\searchInEditorDatabase($line['name'],$editorDatabase);
	                        if(!empty($editor))
	                        {
	                        	if($line['type']=='SOFTWARE')
	                        	{
	                        		if(array_key_exists('type', $editor))
	                        		{
	                            		$line['type'] = $editor['type'];
	                        		}
	                        	}
	                        	if(!empty($editor['editor']))
	                        	{
	                            	$line['manufacturer'] = $editor['editor'];
	                        	}
	                        }
                        }

	                    //on vérifie si on doit mettre à jour ou insérer
	                    $builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
	                    if($builtid == 0)
	                    {
	                    	$softId = cron\inventory\getSoftwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
	                    	$insert= Model_inventory::addSoftwareComponentOnNode($dbconnection,$node->getId(),$line['name'],$line['fullname'],$softId,$line['version'],NULL,'SNMP');
	                    }
	                    elseif($builtid > 0)
	                    {
	                    	$insert = Model_inventory::updateSoftwareComponentOnNode($dbconnection,$builtid,$line['fullname'],$line['version'],NULL);
	                    }
	                    else
	                    {
	                    	$insert=-1;
	                    }
                        if(is_numeric($insert))
                        {
                            $isbuilt_insert++;
                            $linkednodetab=true;
                        }
                    }
                    catch (Exception $e)
                    {
                        echo $node->getName()." INSERT OS ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['fullname'];
                    	//exit(0);
                    }
                }
                //Récupération des informations sur la machine
                $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
                $json = execImportPlugin($node,DEFAULT_INVENTORY_SCAN,$parameter.' -T os');
                foreach($json as $line)
                {
                    try
                    {
                            if($line['type']=='NETIN')
                            {
                                $vendor = Model_inventory::getVendorByMac($dbconnection,$line['option']['macAdress']);
                                $line['manufacturer']= $vendor;
                                if(empty($line['name']))
                                {
                                	$line['name'] = $line['fullname'];
                                }
                            }
                            //on vérifie si on doit mettre à jour ou insérer
                            $builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
                            if($builtid == 0)
                            {
                            	if($line['type']=='NETIN')
                            	{
                            		//returne l'identifiant du fabricant/éditeur associé, s'il n'existe pas. Il est ajouté en base de donnée
                            		$netid = cron\inventory\getNetInComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
                            		$insert= Model_inventory::addNetinComponentOnNode($dbconnection,$node->getId(),$line['name'],$line['fullname'],$netid,$line['hardwareVersion'],$line['option']['macAdress'],$line['option']['IP']);
                            	}
                            	else
                            	{
                            		$descr = $line['name'].' '.$line['model'].' '.$line['hardwareVersion'];
                            		$componentID = cron\inventory\getHardwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
                            		echo "insert ".$node->getName()." ".$line['model']." ".$componentID."\n";
									if(empty($line['serial']))
									{
										$line['serial'] = null;
									}
                            		$insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['model'],$descr,$line['serial'],$componentID,$line['firmwareVersion'],NULL,'SNMP');
                            	}
                            }
                            elseif($builtid > 0)
                            {
                            	if($line['type']=='NETIN')
                            	{
                            		if(empty($line['fullname']))
                            		{
                            			$line['fullname'] = $line['name'];
                            		}
                            		$insert = Model_inventory::updateNetinComponentOnNode($dbconnection,$builtid,$line['fullname'],$line['version'],$line['option']['macAdress'],$line['option']['IP']);
                            	}
                            	else
                            	{
									if( empty($descr))
									{
										$descr = NULL;
									}
									if(empty($line['version']))
									{
										$line['version'] = NULL;
									}
                            		$insert = Model_inventory::updateHardwareComponentOnNode($dbconnection,$builtid,$descr,$line['version'],$line['option']);
                            	}
                            }
                            else
                            {
                            	$insert=-1;
                            }
                            if(is_numeric($insert))
                            {
                                $isbuilt_insert++;
                                $linkednodetab=true;
                            }
                    }
                    catch (Exception $e)
                    {
                    	echo $node->getName()." INSERT HARDWARE ERROR: ".$line['manufacturer']." T".$line['type']." ".$line['name']." mode".$line['model'];
					}
                }
	    	}
            else
            {

				//TODO
                $flag_default_importation=TRUE;
	        	if(!empty($patternfound))
	        	{
	        		$list_exec = array();
	        		$patternfound = array_shift($patternfound);
	        		foreach($patternfound['plugins'] as $plug)
	        		{
	        			if(preg_match('#CHECK_SNMP#',$plug['plugin_name']))
	        			{
	        				if( !in_array($plug['path'],$list_exec))
	        				{
	        					$list_exec[] = 	$plug['path'];
	        				}

	        			}
	        			elseif(preg_match('#GESA_SNMP#',$plug['plugin_name']))
	        			{
	        				if(preg_match('#\-c\s+([0-9A-Za-z\_\.]*)#',$plug['parameter'],$regs ))
	        				{
	        					$command=$regs[1];
		        				$content_file = @file_get_contents(NRPE_COMMANDS_FILE);
		        				if( $content_file !== FALSE )
		        				{
		        					if(preg_match("/^\s*command\[$command\]=(.*)$/m",$content_file,$matches) && count($matches) >= 2 )
		        					{
		        						$exp = explode(" ",$matches[1],2);
		        						$file_name = basename($exp[0]);
		        						$list_exec[] = 	$file_name;
		        					}
		        				}
	        				}
	        			}
	        		}
	        		//DEFAULT_INVENTORY_PLUGIN_PARAMETER
	        		cron\inventory\trace($debug, "PATTERN IMPORT: ".$node->getName()."\n");
	        		cron\inventory\trace($debug, $list_exec);
	        		foreach ($list_exec as $exec)
	        		{
	        			try
	        			{
						    $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_PLUGIN_PARAMETER,$node);
						    $json = execImportPlugin($node,$exec,$parameter);
				            foreach($json as $line)
				            {
				                try
				                {
				                	//returne l'identifiant du fabricant/éditeur associé, s'il n'existe pas. Il est ajouté en base de donnée

				                	//on vérifie si on doit mettre à jour ou insérer
				                	$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
				                	$descr = $line['fullname'].' '.$line['model'].' '.$line['hardwareVersion'];
				                	if($builtid == 0)
				                	{
				                		$componentID = cron\inventory\getHardwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
				                		//echo "insert ".$node->getName()." ".$line['model']." ".$componentID."\n";
				                		$insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['model'],
				                			$descr,$line['serial'],$componentID,$line['firmwareVersion'],NULL);
				                	}
				                	elseif($builtid > 0)
				                	{
				                		$insert = Model_inventory::updateHardwareComponentOnNode($dbconnection,$builtid,$descr,$line['version'],$line['option']);
				                	}
				                	else
				                	{
				                		$insert=-1;
				                	}
				                	if(is_numeric($insert))
				                	{
				                		$isbuilt_insert++;
				                		$linkednodetab=true;
				                	}
				                    $flag_default_importation=FALSE;
				                }
				                catch(Exception $e)
				                {
				                    echo $node->getName()." INSERT PLUGIN_PARAMETER ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
				                }
				            }
						}
	                    catch (Exception $e)
	                    {
	                        echo $node->getName()." INSERT PLUGIN_PARAMETER ERROR: ".$e->getMessage()."\n";
	                    }
					}
	        	}
	        	//print_r($patternfound);
                //RECHER PAR DEFAUT SUR LES PATTERNS
	        	if($flag_default_importation)
	        	{
	        		cron\inventory\trace($debug, "DEFAULT IMPORT: ".$node->getName()."\n");
	        		cron\inventory\trace($debug, $list_exec);
		            $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
		            $json = execImportPlugin($node,DEFAULT_INVENTORY_SCAN,$parameter);
		          //  print_R($json);exit(0);
                    foreach($json as $line)
                    {
                        try
                        {
                        	//on vérifie si on doit mettre à jour ou insérer
                        	cron\inventory\trace($debug, "DEFAULT IMPORT OUTPUT");
                        	cron\inventory\trace($debug, $line);
                        	$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
                        	cron\inventory\trace($debug, $builtid);
                        	$descr = $line['model'].' '.$line['hardwareVersion'];
                        	if($builtid == 0)
                        	{
                        		$componentID = cron\inventory\getHardwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);

                        		$insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['model'],
                        			$descr,$line['serial'],$componentID,$line['firmwareVersion'],NULL);
                        	}
                        	elseif($builtid > 0)
                        	{
                        		$insert = Model_inventory::updateHardwareComponentOnNode($dbconnection,$builtid,$descr,$line['version'],$line['option']);
                        	}
                        	else
                        	{
                        		$insert=-1;
                        	}
                        	if(is_numeric($insert))
                        	{
                        		$isbuilt_insert++;
                        		$linkednodetab=true;
                        	}
                        }
                        catch (Exception $e)
                        {
                            echo $node->getName()." INSERT PATTERN ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
                        }
                    }
	        	}
	        	if(!empty($patternfound) && $isbuilt_insert == 0)
	        	{
	        		echo "\nDEFAULT manufacturer\n";
	        		try
	        		{
						$name = IANA::getManufacturerLogo($objectid, $sysdescr);
						$line = array('name'=>'unknown','type'=>'CHASSIS','manufacturer'=>$name['name'] );

						$builtid = cron\inventory\insertOrUpdateComponent($line,$built_component);
						if($builtid == 0)
						{
							$componentID = cron\inventory\getHardwareComponentId($dbconnection,$line['name'],$line['type'],$line['manufacturer'],$element);
							//echo "insert ".$node->getName()." ".$line['name']."\n";
							$insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['name'],'','',$componentID,'',NULL);
						}
						else
						{
							$insert=-1;
						}
						if(is_numeric($insert))
						{
							$isbuilt_insert++;
							$linkednodetab=true;
						}

					}
                   	catch (Exception $e)
                    {
						echo $node->getName()." INSERT DEFAULT MANUFACTURER ERROR: ".$name['name']."\n";
                    }
	        	}
            }
	    }
	    //liaison automatique avec l'onglet Noeud
	    if($linkednodetab)
	    {
	   		Model_esia::addNodeTabs($dbconnection, $node->getId(), 'TAB_INVENTORY');
	    }
	    foreach($built_component as $compo)
	    {
	    	if(!array_key_exists('found', $compo))
	    	{
	    		cron\inventory\trace($debug, 'DELETE'.$node->getName().' '.$compo['component']);
				Model_inventory::deleteComponentOnNode($dbconnection,  $compo['built_id'], $node->getId());
	    	}
	    }
	}
	catch (SnmpException $e)
	{
		echo $node->getName()." SNMP ERROR: ".$e->getMessage();
	}
	catch (DeviceSnmpException $e)
	{
		echo $node->getName()." SNMP ERROR: ".$e->getMessage();
	}
	catch (Exception $e)
	{
		echo $node->getName()." GLOBAL ERROR: ".$e->getMessage();
	}
}
echo "OK: end import\n ";
exit(0);
function execImportPlugin($node,$path,$parameter)
{
	$arr=array();
	$ret=1;
	$exec=$path;
	$output ="";
	if(@get_class($node)=='RemoteDevice' || @get_class($node)=='RemoteServer'  || @get_class($node)=='RemoteSwitch' )
	{
		$output = $node->getGESA()->execByECATP($path,$parameter,120);
		$output= $output['data'][0];
		$ret=0;
	}
    else
    {
    	if(strpos($path,DEFAULT_INVENTORY_PLUGIN_PATH)===FALSE)
    	{
    		$exec=DEFAULT_INVENTORY_PLUGIN_PATH.$path;
    	}
    	exec("$exec $parameter",$arr,$ret);
    	$output="";
    	foreach($arr as $line)
    	{
    		$output.=$line;
    	}
    	$output = trim($output);
    }
    if($ret == 0 && !empty($output))
    {
        $json = json_decode($output,true);
        //On test si le JSON est valide
        if(json_last_error() === JSON_ERROR_NONE)
        {
            return $json;
        }
        else
        {
            throw new Exception("BAD JSON FORMAT error $output");
        }
    }
    else
    {
        throw new Exception("Exec error $path $parameter");
    }
}
function defaultHardwareImportation($dbconnection,$node)
{
    $arr= NULL;
	$parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
	$json = execImportPlugin($node,DEFAULT_INVENTORY_SCAN,$parameter);
	foreach($json as $line)
	{
		try
		{
			if(empty($line['manufacturer']))
			{
				$line['manufacturer']="unknown";
		   	}
			$manufacturer = manufacturer_exist($line['manufacturer'],$element['manufacturer']);
			if($manufacturer === FALSE)
			{
				// il faut ajouter le fabricant
				$id = Model_inventory::addManufacturer($dbconnection,$line['manufacturer']);
				$element['manufacturer'][$id]=$line['manufacturer'];
				$manufacturer = $id;
			}
			$tmp = strtoupper($line['type']);
			$type = type_exist($tmp,$hardwareType);
			if($type === FALSE)
			{
				// il faut ajouter le type
			 	$id = Model_inventory::addType($dbconnection,$tmp,'HARDWARE');
			   	$hardwareType[$id]=$tmp;
			    $type = $id;
			}
			$descr = $line['model'].' '.$line['hardwareVersion'];
			$model = model_exist($element['component'],$line['model'],$manufacturer,$type);
			if($model === FALSE)
			{
				// il faut ajouter le fabricant
			   	$id = Model_inventory::addComponent($dbconnection,$line['name'],"$descr",$line['model'],$type,$manufacturer);
				$element['component'][]=array('model'=>$line['model'],'manufacturer'=>$manufacturer,'type'=>$type );
				$model = $id;
			}
			$insert= Model_inventory::addComponentOnNode($dbconnection,$node->getId(),$line['model'],
			                    												$descr,$line['serial'],$model,$line['firmwareVersion'],NULL);
			if(is_numeric($insert))
			{
				$isbuilt_insert++;
			}

		}
		catch (Exception $e)
		{
			echo $node->getName()." INSERT defaultHardwareImportation ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
		}
	}
}
?>
