<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux

//$ESIA_WIDGET_NOTREE=TRUE;
$webp_name='inventory';
//$webp_model='model_'.$webp_name.'.php';

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
//Inclusion des librairie
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 */

include_once $path.'/Model_adm.php';
include_once 'inventory.conf.php';
include_once MODEL_INVENTORY;
include_once LIB_INVENTORY;


$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $arr[0]['apache_path'];
$smarty->assign('plugin_url',$plugin_url);
$page_url = "$plugin_url".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';
$smarty->assign('lang',  $lang);
//valeur par défaut

if(!empty($_GET['action']))
{
    $action = $_GET['action'];
}
session_write_close();

$errors = array();
try
{
    $groupId = 0;
    if(!empty($_REQUEST['group']) && is_numeric($_REQUEST['group']))
    {
        $groupId = intval($_REQUEST['group']);
    }
    $smarty->assign('groupId', $groupId);

    if($action == "add" || $action == "update")
    {
        if(isset($_POST['rule_id']) && !empty($_POST['name']))
        {
            $ruleArray = array();
            $ruleArray['name'] = $_POST['name'];
            $ruleArray['component_id'] = $_POST['component'];
            $ruleArray['target_version'] = $_POST['version_target'];
            $ruleArray['operator_target'] = $_POST['operator'];
            $ruleArray['match'] = NULL;
            $ruleArray['description'] = $_POST['description'];
            $ruleArray['activate'] = $_POST['active'];

            $ruleArray['target'] = array(
                'groups' => array(),
                'devices' => array(),
            );
            if(isset($_POST['targetDevice']) && is_array($_POST['targetDevice']))
            {
                $ruleArray['target']['devices'] = $_POST['targetDevice'];
            }
            if(isset($_POST['targetGroup']) && is_array($_POST['targetGroup']))
            {
                $ruleArray['target']['groups'] = $_POST['targetGroup'];
            }

            if($action == "add")
            {
                $newId = Model_inventory::addRules($dbconnection, $ruleArray);
                $smarty->assign('success', $lang['INVENTORY_RULE_ADD_SUCCESS']);

                // When add action is over set it to update to display update page
                $action = "update";
                $_REQUEST['rule'] = $newId;
            }
            elseif($action == "update")
            {
                Model_inventory::updateRule($dbconnection, $_POST['rule_id'], $ruleArray);
                $smarty->assign('success', $lang['INVENTORY_RULE_UPDT_SUCCESS']);
                $_REQUEST['rule'] = $_POST['rule_id'];
            }
        }
        // Data for view
        // Get components list
        $componentsList = Model_inventory::getGroupedComponents($dbconnection,"OS-COMPONENT");
        $smarty->assign('componentsList', $componentsList);

        $typeList = Model_inventory::getGroupedTypeComponents($dbconnection);
        $smarty->assign('type_list',$typeList);

        $devices = Model_esia::getNodeList($dbconnection, $user->getId());
        $groups = Model_inventory::getAvaillableNodeGroupsByUser($dbconnection, $user->getId());

        $smarty->assign('devices', $devices);
        $smarty->assign('groups', $groups);
        $smarty->assign('INV_RULES_OPERATORS', INV_RULES_OPERATORS);

        $ruleId = 0; // No rule id for add action
        $rule = array();
        if($action == "update")
        {
            if(empty($_REQUEST['rule']))
            {
                throw new Exception($lang['INVENTORY_ERROR_RULE_ID']);
            }
            // Get current rule informations
            $ruleId = intval($_REQUEST['rule']);
            $rule = Model_inventory::getListRules($dbconnection, $ruleId);
            $rule = $rule[$ruleId];
            $type = Model_inventory::getTypeByComponentId($dbconnection,$rule['component_id']);
            $smarty->assign('selected_type',$type['type_name']);

            $componentsList = Model_inventory::getGroupedComponents($dbconnection,$type['type_name']);
            $smarty->assign('componentsList', $componentsList);
        }

        $smarty->assign('ruleId', $ruleId);
        $smarty->assign('rule', $rule);

    }
    // Traitement AJAX sur les filtres des composants
    elseif($_POST['action'] == "select_type")
    {
        $filtred_components = Model_inventory::getGroupedComponents($dbconnection,$_POST['type_selected']);
        //echo '<pre>'; print_r($filtred_components[$_POST['type_selected']]);
        echo json_encode($filtred_components[$_POST['type_selected']]);
		exit(0);
    }
    elseif($action == "detail")
    {
        $tab = '';
        if(!empty($_GET['tab']))
        {
            $tab = $_GET['tab'];
        }

        if($tab == 'conf')
        {
            $rule = Model_inventory::getListRules($dbconnection, $_GET['ruleId']);
            $rule = $rule[$_GET['ruleId']];
            $smarty->assign('rule', $rule);
            $targetList = array(
                'groups' => array(),
                'devices' => array(),
            );
            if(!empty($rule['target']['groups']))
            {
                $targetList['groups'] = Model_inventory::getGroupById($dbconnection, $rule['target']['groups']);
            }
            if(!empty($rule['target']['devices']))
            {
                $targetList['devices'] = Model_inventory::getAllDevice($dbconnection, $rule['target']['devices']);
            }
            $smarty->assign('targetList', $targetList);
        }
        elseif($tab == 'components')
        {
            // Get rule results informations
            // This tab is set by ajax tablesorter
            $smarty->assign('rule', $_GET['ruleId']);
        }

        $smarty->assign('tab', $tab);
        $smarty->assign('ruleId', $_GET['rule']);
    }
    elseif($action == "delete" )
    {
        if(is_numeric($_GET['rule']))
        {
            $idRule = $_GET['rule'];
            $smarty->assign('idRule', $idRule);
            if(isset($_POST['deleteConfirmed']) && $_POST['deleteConfirmed'] == $idRule)
            {
                Model_inventory::deleteRule($dbconnection,$idRule);
                $smarty->assign('success', $lang['INVENTORY_DELETE_SUCCESS']);
            }
        }
    }
    elseif($action == "detailImport")
    {
        if(empty($_GET['task']))
        {
            throw new Exception('Task ID is missing');
        }
        $task = Model_esia::getCronActiveTasks($dbconnection, $_GET['task'])[0];
        // Get data from cron parameter
		$parameters = parsePluginParameters($task['parameter']);
		$intervalStr = convertIntervalNbrToStr($task['interval']);
        $task['interval'] = $lang['INVENTORY_SCAN_INTERVAL_' . strtoupper($intervalStr)];
        $task['scan_type'] = getScanTypeByCronPlugName($task['name']);

        $smarty->assign('task', $task);

        // Get group names
        $groupIds = explode(',', $parameters['g']);
        $groups = Model_inventory::getGroupById($dbconnection, $groupIds);
        $smarty->assign('groups', $groups);

        if(file_exists($task['last_filelog']))
        {
            $content = file_get_contents($task['last_filelog']);
            if($content)
            {
                $smarty->assign('content', $content);
            }
            else
            {
                throw new Exception('Cannot read file');
            }
        }
        else
        {
            throw new Exception('Log file does not exist');
        }
    }
    elseif($action == "addImport" || $action == "updateImport")
    {
        $pwsh_hide_password = '**********';
        $task_id = $_REQUEST['task'];
        if(isset($_POST['confirmId']) && $_POST['confirmId'] == $_GET['task'])
		{
			/*
			** Validation form sended
			*/
            if(empty($_POST['scanImportGroup']))
            {
                throw new Exception($lang['INVENTORY_ERROR_GROUP_PARAM']);
            }
            if(empty($_POST['importNextExecDate']) || empty($_POST['importNextExecTime']))
            {
                throw new Exception($lang['INVENTORY_ERROR_DATE_PARAM']);
            }
            if(!isset($_POST['scanImportInterval']))
            {
                throw new Exception($lang['INVENTORY_ERROR_INTERVAL_PARAM']);
            }

            // Format data
            $nextDate = date_create_from_format("Y-m-d H:i", $_POST['importNextExecDate'] . ' ' . $_POST['importNextExecTime']);
            $parameters = array('g' => $_POST['scanImportGroup']);

            //Powershell and SNMP - add only
            if($action == "addImport")
            {
                $smarty->assign('groupId', $_POST['scanImportGroup']);
                if(!isset($_POST['scanImportType']))
                {
                    throw new Exception($lang['INVENTORY_ERROR_TYPE_PARAM']);
                }

                $newId = Model_inventory::addScan($dbconnection, 'import', $_POST['scanImportType'], $nextDate->getTimestamp(), $_POST['scanImportInterval'], $parameters);
                $smarty->assign('success', $lang['INVENTORY_SCAN_IMPORT_ADD_SUCCESS']);

                // When add action is over set it to update to display update page
                $action = "updateImport";
                $task_id = $newId;
            }

            //Powershell Only
            $file_path = '/inventory/pwsh_'.$task_id;
			if( isset($_REQUEST['radio-auth-mode']) && $_REQUEST['radio-auth-mode'])
			{
                $parameters['i'] = $task_id;

				$adv_login = $_REQUEST['adv_login'];
				$adv_pwd = $_REQUEST['adv_pwd'];

                if( isExistFile($file_path) )
                {
                    $data = getSettingsFromEncryptedFile($dbconnection,$file_path);
                    $data = json_decode($data,TRUE);
                    if( $data['user'] != $_REQUEST['adv_login'])
                    {
                        $change = TRUE;
                        $data['user'] = $_REQUEST['adv_login'];
                    }
                    if( $data['password'] != $_REQUEST['adv_pwd'] && $_REQUEST['adv_pwd'] != $pwsh_hide_password )
                    {
                        $change = TRUE;
                        $data['password'] = $_REQUEST['adv_pwd'];
                    }
                }
                else
                {
                    $change = TRUE;
                    $data['user'] = $_REQUEST['adv_login'];
                    $data['password'] = $_REQUEST['adv_pwd'];
                }

                if( $change )
                {
                    saveSettingsInEncryptedFile($dbconnection,$file_path,json_encode($data,TRUE),TRUE);
                }
			}
			else
			{
				removeData($file_path);
			}
            //Powershell and SNMP - add/update Powershell or update SNMP
            if($action == "updateImport" || ( isset($_REQUEST['radio-auth-mode']) && $_REQUEST['radio-auth-mode'] ))
            {
                Model_inventory::updateScan($dbconnection, $task_id, $nextDate->getTimestamp(), $_POST['scanImportInterval'], $parameters);
                $smarty->assign('success', $lang['INVENTORY_SCAN_IMPORT_UPDT_SUCCESS']);
            }
		}
        /*
        ** Display html content
        */
        if($action == "updateImport")
        {
            // Get task
            $task = Model_esia::getCronActiveTasks($dbconnection, $task_id)[0];

            // Get data from cron parameter
            $parameters = parsePluginParameters($task['parameter']);

            $task['interval'] = convertIntervalNbrToStr($task['interval']);
            $task['scan_type'] = getScanTypeByCronPlugName($task['name']);
            $task['list_groups'] = explode(',', $parameters['g']);
            $smarty->assign('task', $task);
            // Format date
            $importNextDate = date_create_from_format("d/m/Y H:i:s", $task['next_exec']);
        }
        else
        {
            // For add action set task id to 0
            $smarty->assign('task', array('id' => 0));
            // Get types scan (only for add because we cannot update scan type)
		    $smarty->assign('typeScan', INV_IMPORT_SCAN_TYPES);
            // Format date
		    $importNextDate = new DateTime('+1 hour');
        }
        if( $action == "updateImport" && $task['scan_type'] == 'Powershell' )
        {
            $file_path = '/inventory/pwsh_'.$task['id'];
            if( isExistFile($file_path))
            {
                $data = getSettingsFromEncryptedFile($dbconnection,$file_path);
                $data = json_decode($data,TRUE);
                $smarty->assign('adv_param_login', $data['user']);
                $smarty->assign('adv_param_pwd', $pwsh_hide_password);
            }
            else
            {
                $smarty->assign('adv_param_login', '');
                $smarty->assign('adv_param_password','');
            }
        }

        // Format date
        $importNextExec = explode("*", $importNextDate->format('Y-m-d*H:i'));
		$smarty->assign('importNextExecDate', $importNextExec[0]);
		$smarty->assign('importNextExecTime', $importNextExec[1]);

		// Interval list
		$intervalList = array();
		foreach(INV_IMPORT_VALID_INTERVALS as $interval)
		{
			$intervalList[] = array('value' => $interval, 'text' => $lang['INVENTORY_SCAN_INTERVAL_' . strtoupper($interval)]);
		}
		$smarty->assign('intervalList', $intervalList);
        // Get node group list
		$groupList = Model_esia::getGroupDeviceByUser($dbconnection, $user->getId());
		$smarty->assign('groupList', $groupList);
		// Min & max date values
		$thresholdDate = new DateTime();
		$smarty->assign('minDate', $thresholdDate->format('Y-m-d'));
		$thresholdDate->modify('+2 year');
		$smarty->assign('maxDate', $thresholdDate->format('Y-m-d'));
    }
    elseif($action == "deleteImport")
    {
        if(!empty($_POST['confirmId']) && $_POST['confirmId'] == $_GET['task'])
		{
			/*
			** Validation form sended
			*/
			Model_esia::deleteCronTask($dbconnection, $_GET['task']);
			$smarty->assign('success', $lang['INVENTORY_DELETE_SUCCESS']);
		}
		else
		{
			/*
			** Display html content
			*/
			$smarty->assign('taskId', $_GET['task']);
		}
    }
    elseif($action == "getImportErrLog")
    {
        if(empty($_GET['task']))
        {
            throw new Exception('Task ID is missing');
        }
        if(empty($_GET['log']))
        {
            throw new Exception('Log file name is missing');
        }

        $filePath = $path . '/data/cron/archive/' . $_GET['task'] . '/' . $_GET['log'];
        if(file_exists($filePath))
        {
            $content = file_get_contents($filePath);
            if($content)
            {
                $smarty->assign('content', $content);
            }
            else
            {
                throw new Exception('Cannot read file');
            }
        }
        else
        {
            throw new Exception('Log file does not exist');
        }
    }
    else
    {
        echo "Action not found\n";
    }
}
catch(EsiaDbException | Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);

$smarty->display($template_path.'dialog_inventory.html');
?>
