<?php
/*
** @name display_inventory.php
**
** @description: controller for inventory ajax requests
** @author: Quentin George <q.george@esia-sa.com>
** @date: 14/03/2023
*/
$path = $_SERVER['DOCUMENT_ROOT'];

//Inclusion des librairie
include_once $path . '/common.php';
include_once 'inventory.conf.php';
include_once MODEL_INVENTORY;
include_once LIB_INVENTORY;


if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
	$action = $_POST['action'];
}

try
{
	if($action == "updateScanRulesConfig")
	{
		if(empty($_POST['rulesNextExecDate']) || empty($_POST['rulesNextExecTime']))
		{
			throw new Exception($lang['INVENTORY_ERROR_DATE_PARAM']);
		}
		if(!isset($_POST['scanRulesInterval']) || !in_array($_POST['scanRulesInterval'], INV_RULES_VALID_INTERVALS))
		{
			throw new Exception($lang['INVENTORY_ERROR_INTERVAL_PARAM']);
		}

		$cronPlugRule = Model_esia::getCronPlugin($dbconnection, Model_inventory::PLUGIN_CRON_RULE)[0];
		$task = Model_esia::getCronActiveTasks($dbconnection, NULL, $cronPlugRule['id'], NULL, TRUE)[0];

		// Format data
		$nextDate = date_create_from_format("Y-m-d H:i", $_POST['rulesNextExecDate'] . ' ' . $_POST['rulesNextExecTime']);

		if(empty($task))
		{
			Model_inventory::addScan($dbconnection, 'rule', '', $nextDate->getTimestamp(), $_POST['scanRulesInterval']);
		}
		else
		{
			Model_inventory::updateScan($dbconnection, $task['id'], $nextDate->getTimestamp(), $_POST['scanRulesInterval']);
		}

		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_RULES_PARAM_SUCCESS']);
	}
	elseif($action == "execScanRulesNow")
	{
		$cronPlugRule = Model_esia::getCronPlugin($dbconnection, Model_inventory::PLUGIN_CRON_RULE)[0];
		$task = Model_esia::getCronActiveTasks($dbconnection, NULL, $cronPlugRule['id'], NULL, FALSE)[0];

		if(empty($task) || $task['status'] != 'PENDING')
		{
			$nextDate = new DateTime();
			$nextDate->modify('+5 minutes');
			Model_inventory::addScan($dbconnection, 'rule', '', $nextDate->getTimestamp(), $_POST['scanRulesInterval']);
		}
		else
		{
			throw new Exception($lang['INVENTORY_RULE_EXEC_NOW_PENDING']);
		}

		// If everything was ok send success message
		echo json_encode($lang['INVENTORY_SCAN_RULES_NOW_SUCCESS']);
	}
}
catch(EsiaDbException | Exception $e)
{
	echo json_encode(array('errors' => $e->getMessage()));
}

exit(0);

?>
