<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */

$path = $_SERVER['DOCUMENT_ROOT'];
$path.='/';
include $path."/dashboard/common_widget.php";
$smarty->assign('dashboard_path',$path."/dashboard/");

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $path.$arr[0]['apache_path'];
include_once $plugin_url.'inventory.conf.php';
include_once $plugin_url.MODEL_INVENTORY;
include_once $plugin_url.LIB_INVENTORY;
if($action == 'update')
{
    $parameters = $widget['option'];
    if(!empty($_POST['widgetid']))
    {
        try
        {
            $widget = getPostDefaultParams($widget,$_POST);
            $parameters = $widget['option'];
            $parameters['graphic'] = $_POST['graphic'];
            $parameters['hardware'] = $_POST['hardware'];
            $parameters['software'] = $_POST['software'];
            $parameters['nodes'] = $_POST['nodes'];
            $parameters['groupnodes'] = $_POST['groupnodes'];            
            $parameters['target'] = $_POST['target'];
            $parameters['legend_position'] = $_POST['legend_position'];
            $parameters['limit'] = $_POST['limit'];
            
            $paramSave = json_encode($parameters);
                
            Model_esia::updateWidget($dbconnection,$widget['id'], $widget['name'], $widget['description'], $widget['during'], $parameters);
            //la variable l_success est affichée en rouge dans le smarty
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
        }
        catch(EsiaDbException $e)
        {
            //la variable l_error est affichée en rouge dans le smarty
            $smarty->assign('l_error',$e->getMessage());
        }
        catch(Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }

    //Récupération des styles
    $title = $parameters['title']['style'];
    $description = $parameters['description']['style'];
    $title = getWidgetStyle($title,14,'left','#575759');
    $description = getWidgetStyle($description,12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);

    $smarty->assign('limit',(int)$parameters['limit']);
    if($widget['view_name'] == "DASHBOARD_INVENTORY_NODE")
    {
        $parameters['type'] = "NODE";
        $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
        $list=array();
        foreach($nodes as $node)
        {
            $selected = 'no';
            if(in_array($node->getId(), $parameters['nodes']))
            {
                $selected = 'yes';
            }
            $list[] = array(
                'id' => $node->getId(),
                'name' => $node->getGroup() . '>' . $node->getName(),
                'selected' => $selected,
            );
        }
    }
    elseif($widget['view_name'] == "DASHBOARD_INVENTORY_GROUP_NODE")
    {
        $parameters['type'] = "GROUPNODE";
        $arr = Model_esia::getGroupDevice($dbconnection,null,$user->getId());
        $list_group_node = array();
        foreach($arr as $group)
        {
            $select = 'no';
            if(in_array($group['id'], $parameters['groupnodes']))
            {
                $select = 'yes';
            }
            $list_group_node[] = array(
                'id' => $group['id'],
                'name' => $group['fullpath'],
                'selected' => $select,
            );
        }
    }
    else
    {
        $parameters['type'] = "GLOBAL";
    }
    $smarty->assign('adm_list_group_node', $list_group_node);
    $smarty->assign('adm_list_node', $list);

    if(empty($parameters['graphic']))
    {
        $parameters['graphic'] = 'DONUT';
    }

    $smarty->assign('param', $parameters);
}
else
{
    $parameters = $widget['option'];

    // Chart type
    if(empty($parameters['graphic']))
    {
        $parameters['graphic'] = 'DONUT';
    }

    // Manufacturers data
    if(!isset($parameters['nodes']))
    {
        $parameters['nodes'] = NULL;
    }
    if(!isset($parameters['groupnodes']))
    {
        $parameters['groupnodes'] = NULL;
    }
    if(!isset($parameters['target']))
    {
        $parameters['target'] = NULL;
    }
    if(!isset($parameters['limit']))
    {
        $parameters['limit'] = NULL;
    }
    $manufacturers = Model_inventory::getCountManufacturer($dbconnection, $user->getId(), $parameters['nodes'], $parameters['groupnodes'], $parameters['target'], $parameters['limit']);

    // Legend
    $legendPos = 'bottom';
    if(isset($parameters['legend_position']) && $parameters['legend_position'] == 'RIGHT')
    {
        $legendPos = 'right';
    }

    $smarty->assign('widget_id', $widget['id']);
    $smarty->assign('type_graphic', $parameters['graphic']);
    $smarty->assign('manufacturers', $manufacturers);
    $smarty->assign('legendPos', $legendPos);
}

$smarty->display($plugin_url.'/widgets/templates/view_manufacturer.html');
?>
