<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
$path = $_SERVER['DOCUMENT_ROOT'];
$path.='/';
include $path."/dashboard/common_widget.php";
$smarty->assign('dashboard_path',$path."/dashboard/");

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $path.$arr[0]['apache_path'];
include_once $plugin_url.'inventory.conf.php';
include_once $plugin_url.MODEL_INVENTORY;
include_once $plugin_url.LIB_INVENTORY;

if($action =='update')
{
    $nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
	$nodesList = array();
	foreach($nodes as $node)
	{
		$nodesList[] = array('id' => $node['id'], 'name' => $node['name']);
	}
    $parameters = $widget['option'];
    if($widget['view_name'] == "DASHBOARD_INVENTORY_R_NODE")
    {
        $parameters['type'] = "NODE";
        $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$parameters['nodes']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected

			);
		}   
    }
    elseif($widget['view_name'] == "DASHBOARD_INVENTORY_R_GR_NODE")
    {
        $parameters['type'] = "GROUPNODE";
        $arr = Model_esia::getGroupDevice($dbconnection,null,$user->getId());
        $list_group_node =array();
        foreach($arr as $group)
        {
        	$select='no';
        	if(in_array($group['id'],$parameters['groupnodes']))
        	{
        		$select='yes';
        	}
        	$list_group_node[]=array('id'=>$group['id'],'name'=>$group['fullpath'],'selected'=>$select);
        }
    }
    else
    {
        $parameters['type'] = "GLOBAL";
    }
    $smarty->assign('adm_list_group_node',$list_group_node);
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('param',$parameters);
    
    
    if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
        try
        {
            $widget = getPostDefaultParams($widget,$_POST);
            
            $parameters['nodes'] = $_POST['nodes'];
            $parameters['groupnodes'] = $_POST['groupnodes'];            
            $parameters['target'] = $_POST['target'];
            $parameters['rules_follow'] = $_POST['rules_follow'];
            $parameters['display_version'] = $_POST['version'];
            
            $paramSave = json_encode($parameters);
                
            Model_esia::updateWidget($dbconnection,$widget['id'], $widget['name'], $widget['description'], $widget['during'], $parameters);
            //la variable l_success est affichée en rouge dans le smarty
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
    
        }
        catch (EsiaDbException $e)
        {
            //la variable l_error est affichée en rouge dans le smarty
            $smarty->assign('l_error',$e->getMessage());
        }
        catch (Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }
    //Récupération des styles
    $title = $parameters['title']['style'];
    $description = $parameters['description']['style'];
    $title = getWidgetStyle($title,14,'left','#575759');
    $description = getWidgetStyle($description,12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    
    
	
}
else
{
     $parameters = $widget['option'];
     
     if($parameters['rules_follow'] == "FOLLOW")
    {
        $follow = "OK";
    }
    elseif($parameters['rules_follow'] == "NOT_FOLLOW")
    {
        $follow = "OUTDATED";
    }
    else
    {
        $follow = "ALL";
    }
    
    if($parameters['type']== "NODE")
    {         
        $rules = Model_inventory::getReportRules($dbconnection,"NODE",$follow,$parameters['nodes']);   
    }
    elseif($parameters['type'] == "GROUPNODE")
    {
        
        $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodes']);
        foreach ($tab_group_node as $node)
        {
            $tab_id_node[] = $node->getId();
        }      
        $rules = Model_inventory::getReportRules($dbconnection,"GROUPNODE",$follow,$tab_id_node);
    }
    else
    {
        $rules = Model_inventory::getReportRules($dbconnection,"ALL",$follow,NULL);
    }
    $smarty->assign('param',$parameters);
    $smarty->assign('rules',$rules);
}


$smarty->display($plugin_url.'/widgets/templates/view_rules.html');
?>
