INSERT INTO esia_web_plugin(web_id, web_name, web_dir_lang, web_php_menu, web_index_page, web_activate, web_plugin_apache_path,web_show_main_menu,web_icon) VALUES (DEFAULT,'WEBP_INVENTORY','lang/','menu_inventory.php','control_inventory.php',true, '/plugin/inventory/',true,'/plugin/inventory/images/menu_inventory.png');

CREATE TABLE public.inventory_component (
	component_id serial NOT NULL,
	component_name character varying(200),
	component_description text,
	component_model character varying(50),
	component_version character varying(10),
	component_type_id int4,
	component_manufacturer_id integer,
	component_json json,
	CONSTRAINT "component_primaryKey" PRIMARY KEY (component_id)
);
-- ddl-end --
ALTER TABLE public.inventory_component OWNER TO esia;
-- ddl-end --

-- object: public.inventory_type | type: TABLE --
-- DROP TABLE IF EXISTS public.inventory_type CASCADE;
CREATE TABLE public.inventory_type (
	type_id serial NOT NULL,
	type_name character varying(20),
	type_type character varying(20) DEFAULT 'HARDWARE',
	CONSTRAINT "inventory_type_primaryKey" PRIMARY KEY (type_id),
	CONSTRAINT inventory_type_check_type CHECK (type_type IN('HARDWARE','SOFTWARE'))
);
-- ddl-end --
ALTER TABLE public.inventory_type OWNER TO esia;
-- ddl-end --

-- object: public.inventory_manufacturer | type: TABLE --
-- DROP TABLE IF EXISTS public.inventory_manufacturer CASCADE;
CREATE TABLE public.inventory_manufacturer (
	manufacturer_id serial NOT NULL,
	manufacturer_name character varying(50),
	manufacturer_oid int4,
	manufacturer_logo_path character varying(100),
	manufacturer_pattern integer,
	CONSTRAINT "manufacturer_primaryKey" PRIMARY KEY (manufacturer_id)
);
-- ddl-end --
ALTER TABLE public.inventory_manufacturer OWNER TO esia;
-- ddl-end --

-- object: public.inventory_is_built | type: TABLE --
-- DROP TABLE IF EXISTS public.inventory_is_built CASCADE;
CREATE TABLE public.inventory_is_built (
	built_id bigserial NOT NULL,
	built_name character varying(50),
	built_description text,
	built_serial_number character varying(20),
	built_device_id bigint,
	built_hardware_id integer,
	built_macaddress macaddr,
	built_ipaddress inet,
	buil_installed_date timestamp DEFAULT NOW(),
	built_json json,
	CONSTRAINT "built_primaryKey" PRIMARY KEY (built_id)
);
-- ddl-end --
ALTER TABLE public.inventory_is_built OWNER TO esia;
-- ddl-end --

-- Table: public.inventory_rules
-- DROP TABLE IF EXISTS public.inventory_rules;
CREATE TABLE IF NOT EXISTS public.inventory_rules
(
    rule_id serial,
    rule_name character varying(50),
    rule_component_id integer,
    rule_version_target character varying(10),
    rule_version_target_operator character varying,
    rule_target json,
    rule_match json,
    rule_description text,
    rule_activate boolean,
    CONSTRAINT "rule_primaryKey" PRIMARY KEY (rule_id)
);

-- ddl-end --
ALTER TABLE public.inventory_rules OWNER TO esia;
-- object: "hardware_foreignKey_type" | type: CONSTRAINT --
-- ALTER TABLE public.inventory_component DROP CONSTRAINT IF EXISTS "hardware_foreignKey_type" CASCADE;
ALTER TABLE public.inventory_component ADD CONSTRAINT "hardware_foreignKey_type" FOREIGN KEY (component_type_id)
REFERENCES public.inventory_type (type_id) MATCH SIMPLE
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: "hardware_foreignKey_manufacturer" | type: CONSTRAINT --
-- ALTER TABLE public.inventory_component DROP CONSTRAINT IF EXISTS "hardware_foreignKey_manufacturer" CASCADE;
ALTER TABLE public.inventory_component ADD CONSTRAINT "hardware_foreignKey_manufacturer" FOREIGN KEY (component_manufacturer_id)
REFERENCES public.inventory_manufacturer (manufacturer_id) MATCH SIMPLE
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: "built_foreignKey_device" | type: CONSTRAINT --
-- ALTER TABLE public.inventory_is_built DROP CONSTRAINT IF EXISTS "built_foreignKey_device" CASCADE;
ALTER TABLE public.inventory_is_built ADD CONSTRAINT "built_foreignKey_device" FOREIGN KEY (built_device_id)
REFERENCES esia_device (device_id) MATCH SIMPLE
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: "built_foreignKey_hardware_id" | type: CONSTRAINT --
-- ALTER TABLE public.inventory_is_built DROP CONSTRAINT IF EXISTS "built_foreignKey_hardware_id" CASCADE;
ALTER TABLE public.inventory_is_built ADD CONSTRAINT "built_foreignKey_hardware_id" FOREIGN KEY (built_hardware_id)
REFERENCES public.inventory_component (component_id) MATCH SIMPLE
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: "rule_foreignKey_component_id" | type: CONSTRAINT --
-- ALTER TABLE public.inventory_rules DROP CONSTRAINT IF EXISTS "rule_foreignKey_component_id" CASCADE;
ALTER TABLE public.inventory_rules ADD CONSTRAINT "rule_foreignKey_component_id" FOREIGN KEY (rule_component_id)
REFERENCES public.inventory_component (component_id) MATCH SIMPLE
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end

-- Constraint: inventory_type_unique
-- ALTER TABLE IF EXISTS public.inventory_type DROP CONSTRAINT IF EXISTS inventory_type_unique;
ALTER TABLE IF EXISTS public.inventory_type
    ADD CONSTRAINT inventory_type_unique UNIQUE (type_name);
-- ddl-end

-- Constraint: inventory_manufacturer_unique
-- ALTER TABLE IF EXISTS public.inventory_manufacturer DROP CONSTRAINT IF EXISTS inventory_manufacturer_unique;
ALTER TABLE IF EXISTS public.inventory_manufacturer
    ADD CONSTRAINT inventory_manufacturer_unique UNIQUE (manufacturer_name);


--DELETE FROM public.inventory_is_built;
--DELETE FROM public.inventory_component;
--DELETE FROM public.inventory_type;
--DELETE FROM public.inventory_manufacturer;

INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'CHASSIS','HARDWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'OS','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'DATABASE','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'MAIL','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'SPECIFIC SOFTWARE','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'BROWSER','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'LIBRARY','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'WEB','SOFTWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'HDD','HARDWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'SSD','HARDWARE');
INSERT INTO inventory_type(type_id, type_name, type_type) VALUES (DEFAULT,'CPU','HARDWARE');
ALTER TABLE public.inventory_is_built ALTER COLUMN built_name TYPE character varying(100) COLLATE pg_catalog."default";
ALTER TABLE public.inventory_component ALTER COLUMN component_model TYPE character varying(75) COLLATE pg_catalog."default";
ALTER TABLE IF EXISTS public.inventory_is_built   ADD COLUMN IF NOT EXISTS built_version character varying(50);
ALTER TABLE IF EXISTS public.inventory_component   DROP COLUMN IF EXISTS component_version;
UPDATE esia_mac_address_vendor SET vendor_mac=(vendor_mac_address||'000000')::macaddr;


--UPDATE
ALTER TABLE IF EXISTS public.inventory_is_built ADD COLUMN IF NOT EXISTS built_rule_match_worst_rule_id integer;
ALTER TABLE IF EXISTS public.inventory_is_built ADD COLUMN IF NOT EXISTS built_rule_match_worst_status character varying(20);
ALTER TABLE IF EXISTS public.inventory_is_built
    ADD CONSTRAINT "built_foreignKey_rule_id" FOREIGN KEY (built_rule_match_worst_rule_id)
    REFERENCES public.inventory_rules (rule_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION
    NOT VALID;
CREATE INDEX IF NOT EXISTS "fki_built_foreignKey_rule_id"
    ON public.inventory_is_built(built_rule_match_worst_rule_id);

-- DASHBOARD
INSERT INTO public.dashboard_widget_group(widget_group_id, widget_group_name, widget_group_order) VALUES (DEFAULT, 'INVENTORY', 80);
INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_GLOBAL','/plugin/inventory/widgets/view_manufacturer.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":""}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));
INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_NODE', '/plugin/inventory/widgets/view_manufacturer.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":"","type":"NODE"}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));
INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_GROUP_NODE', '/plugin/inventory/widgets/view_manufacturer.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":"","type":"GROUPNODE"}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));

INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_R_GLOBAL', '/plugin/inventory/widgets/view_rules.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":""}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));
INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_R_NODE', '/plugin/inventory/widgets/view_rules.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":"","type":"NODE"}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));
INSERT INTO public.dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT, 'DASHBOARD_INVENTORY_R_GR_NODE', '/plugin/inventory/widgets/view_rules.php?id=:widgetid', 30, 100, 300, '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"inventory":"","type":"GROUPNODE"}', (SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name = 'INVENTORY'));


-- REPORT

INSERT INTO public.report_block_group(report_block_group_id, report_block_group_name) VALUES (DEFAULT, 'INVENTORY');
INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_MANUFACTURER_NODE', 'inventory_manufacturer.php', '{"title":{"text":"Inventaire","style":{"text-align":"left", "font-size":"15px", "color":"#575759"}},"description":{"text":"Voici la description d''inventaire par noeud","style":{"text-align":"left", "margin":"auto", "font-size":"12px"}},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"},"type":"noeud","nodeid":"[]"}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));
INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_MANUFACTURER_GLOBAL', 'inventory_manufacturer.php', '{"title":{"text":"Inventaire","style":"text-align: left; font-size:14px; color:#575759;"},"description":{"text":"Voici la description d''inventaire","style":"text-align: left; font-size:12px; color:#575759;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"},"component_description":null,"graphic":"DONUT","hardware":"null","software":null}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));

CREATE INDEX IF NOT EXISTS component_index_type_id
    ON public.inventory_component USING btree
    (component_type_id ASC NULLS LAST);

CREATE INDEX IF NOT EXISTS inv_type_index_type
    ON public.inventory_type USING btree
    (type_type ASC NULLS LAST);
CREATE INDEX IF NOT EXISTS inv_type_index_type_name
    ON public.inventory_type USING btree
    (type_name ASC NULLS LAST)
;
INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_MANUFACTURER_GROUP_NODE', 'inventory_manufacturer.php', '{"title":{"text":"Inventaire ","style":{"text-align":"left", "font-size":"15px", "color":"#575759"}},"description":{"text":"Voici la description d''inventaire par groupe de noeud","style":{"text-align":"left", "margin":"auto", "font-size":"12px"}},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"},"forme":"graph","type":"group_node","groupnodeid":[]}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));

INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_RULES_GLOBAL', 'inventory_rules.php', '{"title":{"text":"Règles","style":{"text-align":"left", "font-size":"15px", "color":"#575759"}},"description":{"text":"Voici la description des règles","style":{"text-align":"left", "margin":"auto", "font-size":"12px"}},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"}}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));
INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_RULES_NODE', 'inventory_rules.php', '{"title":{"text":"Règles","style":{"text-align":"left", "font-size":"15px", "color":"#575759"}},"description":{"text":"Voici la description des règles","style":{"text-align":"left", "margin":"auto", "font-size":"12px"}},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"},"type":"noeud","nodeid":"[]"}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));
INSERT INTO public.report_block(block_id, block_name, block_controller, block_default_parameter, block_group_id)
	VALUES (DEFAULT, 'REPORT_INVENTORY_RULES_GROUP_NODE', 'inventory_rules.php', '{"title":{"text":"Règles ","style":{"text-align":"left", "font-size":"15px", "color":"#575759"}},"description":{"text":"Voici la description des règles","style":{"text-align":"left", "margin":"auto", "font-size":"12px"}},"table":{"class":"arraytop","style":"width:60%; height:60%; margin:auto; border-spacing: 10px 10px;"},"td":{"class":"classtd","style":"font-size:50px"},"forme":"graph","type":"group_node","groupnodeid":[]}', (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name = 'INVENTORY'));



INSERT INTO public.device_tab(	tab_id, tab_name, tab_default_options, tab_url, tab_order, tab_web_id)
VALUES (DEFAULT,'TAB_INVENTORY',NULL,'adv_tab_inventory.php?nodeid=:id', 50, (SELECT web_id FROM esia_web_plugin WHERE web_name='WEBP_INVENTORY'));


-- CRON
INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_default_interval_time,plugin_cron_type,plugin_cron_only_existing)
VALUES ('cron','CRON_INVENTORY_RULES','/usr/local/esia/public_html/plugin/inventory/cron/cron_inventory_rules.php','',86400000,'hour',TRUE);

INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_default_interval_time,plugin_cron_type,plugin_cron_only_existing)
VALUES ('cron','CRON_INVENTORY_IMPORT_SNMP','/usr/local/esia/public_html/plugin/inventory/cron/cron_inventory_import_snmp.php','-g <group_id>',86400000,'hour',FALSE);

INSERT INTO esia_plugins (plugin_type,plugin_name,plugin_path,plugin_default_parameter,plugin_default_interval_time,plugin_cron_type,plugin_cron_only_existing)
VALUES ('cron','CRON_INVENTORY_IMPORT_POWERSHELL','/usr/local/esia/public_html/plugin/inventory/cron/cron_inventory_import_pwsh.php','-g <group_id>',86400000,'hour',FALSE);

INSERT INTO public.esia_cron_plugin(cron_id, cron_plugin_id, cron_interval, cron_next_exec, cron_log_file, cron_retries, cron_retries_interval)
	VALUES (DEFAULT, (SELECT plugin_id FROM esia_plugins WHERE plugin_name='CRON_INVENTORY_RULES') ,'1 day'::interval, NOW()+interval '120 minute','inventory_$SERVICEID_$DATE.log',1,'15 minutes'::interval);

ALTER TABLE IF EXISTS public.inventory_is_built ADD COLUMN built_last_update timestamp without time zone NOT NULL DEFAULT NOW();
ALTER TABLE IF EXISTS public.inventory_is_built ADD COLUMN built_script_insert character varying(20);
